% Save label histo gram and per-pixel confidence maps
function save_predictions2(img_basename, y_segs, path_inf_segment_labels, label_conf_maps, path_inf_conf_maps)

nbr_labels = size(y_segs,2);

% Per segment label histogram prediction
assert(sum(sum(isnan(y_segs))) == 0);
fn_inf_histo = [path_inf_segment_labels, '/', img_basename, '.histo_labels'];
dlmwrite(fn_inf_histo, y_segs, ' ');

% Write per-pixel confidence maps, if given
if (nargin > 3)
    assert(size(label_conf_maps,1) == nbr_labels);
    for k=1:nbr_labels
        fn_conf_map = [path_inf_conf_maps, '/', img_basename, '_label_', num2str(k-1), '.pgm'];
        imwrite(label_conf_maps{k}, fn_conf_map, 'PGM');
    end
end
