%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Experiment-specific
% Root directory for segmentation tree
path_seg_tree_root = '../seg_tree';

% (curr, parent)
levels = [256 -1 ; 226 256 ; 196 226 ; 166 196 ; 136 166 ; 106 136 ; 76 106 ; 46 76 ; 16 46 ];

% Root directory of SHL modules
path_machine_root = 'shl_model1'

%%%%%%%%%%%%% Training %%%%%%%%%%%%%%%%
fn_img_train_list = 'training_basenames.txt';
Ts = [10, 12, 15, 17, 20, 20, 25, 25, 30];
train_params.step_size = 1.5;
train_params.regressor_type = 'RandomForest';
train_params.subsample = -1;
fold_holdout = 30;

%%%%%%%%%%%%% Testing %%%%%%%%%%%%%%%%
fn_img_eval_list ='eval_basenames.txt';
path_inf_tree_root = 'eval_model1';

DO_TRAIN = 0; % flag

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
if (DO_TRAIN)
    assert(length(Ts) == size(levels,1));
    fid = fopen(fn_img_train_list, 'r');
else
    fid = fopen(fn_img_eval_list, 'r');
end
img_basenames = textscan(fid,'%s');
img_basenames = img_basenames{1};
fclose(fid);

tic
for i=1:size(levels,1)
    clear feature_names
    curr_scale = levels(i,1);
    parent_scale = levels(i,2);

    if (curr_scale == 256)
        feature_names{1} = 'color';
        feature_names{2} = 'gist';
        feature_names{3} = 'phog';
    else
        feature_names{1} = 'gould';
        feature_names{2} = 'parent';        
        feature_names{3} = 'chull';
    end
    
    if (DO_TRAIN)
        train_params.T = Ts(i);    
        train_stacked_level(path_seg_tree_root, path_machine_root, curr_scale, ...
            parent_scale, feature_names, img_basenames, train_params, fold_holdout);
    else
        USE_BME = ~strcmp(train_params.regressor_type, 'ExpMaxEnt');
        infer_level(path_seg_tree_root, path_machine_root, path_inf_tree_root, ...
            curr_scale, parent_scale, feature_names, img_basenames, USE_BME);
    end
    disp(['----Finished level ' num2str(curr_scale) '----']);
end
toc

